"""
Contains ctan class
"""

import os
from project import Project
from shared import CSC_MIRROR
import requests
import datefinder # another date finding library
from datetime import datetime, timedelta
import re
import pandas as pd

class ctan(Project):
    """ctan class"""
    @staticmethod
    def check(data, project, current_time):
        page = requests.get(data[project]["upstream"]).text
        indexOfFile = page.find("mirror.csclub.uwaterloo.ca")

        m = re.search(r'(\d+ minutes?)|(\d+ hours?)|(\d+(\.)?\d+ days?)', page[indexOfFile:])


        duration = pd.to_timedelta(m.group(0))
        data[project]["out_of_sync_since"] = datetime.now() - duration

        return duration <= pd.to_timedelta(data[project]["out_of_sync_interval"], unit='s')
